///////////////////////////////////////////////////////////////////////
// Copyright (C) 2006 Jari Korhonen. jarit1.korhonen@dnainternet.net.
// All Rights Reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//
//
// If the source code for the program is not available from the place
// from which you received this file, check
// http://koti.mbnet.fi/jtko
//
//////////////////////////////////////////////////////////////////////


#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <stdarg.h> //debug

#include <sys/types.h>  //ip_conv
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>


#include "repeaterutil.h"
#include "openbsd_stringfuncs.h"

void debug2(int msgLevel, const char *fmt, ...)
{
    va_list args;
    va_start(args, fmt);
    vfprintf(stderr, fmt, args);
    va_end(args);
}

int strpos(char *haystack, char *needle)
{
   char *p = strstr(haystack, needle);
   if (p)
      return p - haystack;
   return -1;
}
//Parse ip address (i'm sure similar function has been recoded thousands of times ;-)
//Return ip address in structure form
addrParts getAddrPartsFromString(char *ipString)
{
    addrParts addr; 
    char tmpBuf[MY_TMP_BUF_LEN + 1];
    int ipVal[8] = {255,255,255,255,65535,65535,65535,65535};
    char *p;
    char *start;
    long value;
    int ii;
    
    if ( strpos( ipString, (char *)":" ) > -1) {	
		struct in6_addr result;
		if (inet_pton(AF_INET6, ipString, &result) == 1) {
			addr.a = ntohs(result.s6_addr16[0]);
			addr.b = ntohs(result.s6_addr16[1]);
			addr.c = ntohs(result.s6_addr16[2]);
			addr.d = ntohs(result.s6_addr16[3]);
			addr.e = ntohs(result.s6_addr16[4]);
			addr.f = ntohs(result.s6_addr16[5]);
			addr.g = ntohs(result.s6_addr16[6]);
			addr.h = ntohs(result.s6_addr16[7]);
		}
		return addr;
    }    
    
    strlcpy(tmpBuf, ipString, MY_TMP_BUF_LEN + 1);
    strlcat(tmpBuf, ".", MY_TMP_BUF_LEN + 1);
    start = tmpBuf;
    
    for(ii = 0; ii < 4; ii++) {
        p = strchr(start, '.');                 
        if (p != NULL) {
            *p = '\0';
            
            value = strtol(start, NULL, 10);
            
            if ((value < 0) || (value > 255)) 
                ipVal[ii] = 255;
            else
                ipVal[ii] = value;

            start = p;
            start++;
        }
        else {
            ipVal[ii] = 255;
        }
    }
    
    addr.a = ipVal[0];
    addr.b = ipVal[1];
    addr.c = ipVal[2];
    addr.d = ipVal[3];    
    
    return addr;    
}

void AddrPartsToString(char * peerIp, addrParts addr) {    
  if ((addr.a<256) && (addr.e>0)) {	  // ::1 -> addr.a is <256 but valid ipv6 
	sprintf(peerIp, "%d.%d.%d.%d",addr.a,addr.b,addr.c,addr.d);
  }
  else {
	sprintf(peerIp, "%04x:%04x:%04x:%04x:%04x:%04x:%04x:%04x",addr.a,addr.b,addr.c,addr.d,addr.e,addr.f,addr.g,addr.h);
  }    
}
